<!-- 
    ROS navigation stack with velocity smoother and safety (reactive) controller
-->
<launch>
  <include file="$(find turtlebot_navigation)/launch/includes/velocity_smoother.launch.xml"/>
  <include file="$(find turtlebot_navigation)/launch/includes/safety_controller.launch.xml"/>
  
  <arg name="odom_frame_id"   default="odom"/>
  <arg name="base_frame_id"   default="base_footprint"/>
  <arg name="global_frame_id" default="map"/>
  <arg name="odom_topic" default="odom" />
  <arg name="laser_topic" default="scan" />
  <arg name="custom_param_file" default="/opt/robot/radar-safety-bubble/param/dummy.yaml"/>

  <node pkg="move_base" type="move_base" respawn="false" name="move_base" output="screen">
    <rosparam file="/opt/robot/radar-safety-bubble/param/quad_sensor/costmap_common_params.yaml" command="load" ns="global_costmap" />
    <rosparam file="/opt/robot/radar-safety-bubble/param/quad_sensor/costmap_common_params.yaml" command="load" ns="local_costmap" />   
    <rosparam file="/opt/robot/radar-safety-bubble/param/quad_sensor/local_costmap_params.yaml" command="load" />   
    <rosparam file="/opt/robot/radar-safety-bubble/param/quad_sensor/global_costmap_params.yaml" command="load" />
    <rosparam file="/opt/robot/radar-safety-bubble/param/quad_sensor/dwa_local_planner_params.yaml" command="load" />
    <rosparam file="/opt/robot/radar-safety-bubble/param/quad_sensor/move_base_params.yaml" command="load" />
    <rosparam file="/opt/robot/radar-safety-bubble/param/quad_sensor/global_planner_params.yaml" command="load" />
    <rosparam file="/opt/robot/radar-safety-bubble/param/quad_sensor/navfn_global_planner_params.yaml" command="load" />
    <!-- external params file that could be loaded into the move_base namespace -->
    <rosparam file="$(arg custom_param_file)" command="load" />
    
    <!-- reset frame_id parameters using user input data -->
    <param name="global_costmap/global_frame" value="$(arg global_frame_id)"/>
    <param name="global_costmap/robot_base_frame" value="$(arg base_frame_id)"/>
    <param name="local_costmap/global_frame" value="$(arg odom_frame_id)"/>
    <param name="local_costmap/robot_base_frame" value="$(arg base_frame_id)"/>
    <param name="DWAPlannerROS/global_frame_id" value="$(arg odom_frame_id)"/>

    <remap from="cmd_vel" to="navigation_velocity_smoother/raw_cmd_vel"/>
    <remap from="odom" to="$(arg odom_topic)"/>
    <remap from="scan" to="$(arg laser_topic)"/>
  </node>
</launch>